#include <stdio.h>
#include <ldap.h>
#include <string.h>

#define SEARCHBASE	"o=Ace Industry, c=US"

main()
{
	LDAP		*ld;
	LDAPMessage	*result, *e;
	char		*dn, *ufn, *attrs[ 2 ];

	if ( (ld = ldap_init( "ldap.netscape.com", LDAP_PORT )) == NULL ) {
		perror( "init" );
		exit( 1 );
	}

	if ( ldap_simple_bind_s( ld, NULL, NULL ) != LDAP_SUCCESS ) {
		ldap_perror( ld, "bind" );
		ldap_unbind( ld );
		exit( 1 );
	}

	attrs[ 0 ] = "sn";
	attrs[ 1 ] = NULL;
	if ( ldap_search_s( ld, SEARCHBASE, LDAP_SCOPE_SUBTREE,
	    "(cn=Jo*)", attrs, 0, &result ) != LDAP_SUCCESS ) {
		ldap_perror( ld, "search" );
		ldap_unbind( ld );
		exit( 1 );
	}

	if ( ldap_sort_entries( ld, &result, "sn", strcmp ) != 0 ) {
		ldap_perror( ld, "sort" );
		/* keep going anyways */
	}

	for ( e = ldap_first_entry( ld, result ); e != NULL;
	    e = ldap_next_entry( ld, e )) {
		if (( dn = ldap_get_dn( ld, e )) != NULL &&
		    ( ufn = ldap_dn2ufn( dn )) != NULL ) {
			puts( dn );
			puts( ufn );
			putchar( '\n' );
			ldap_memfree( dn );
			ldap_memfree( ufn );
		}
	}

	ldap_unbind( ld );
	exit( 0 );
}
