#include <stdio.h>
#include <ldap.h>

main( int argc, char **argv )
{
	LDAP	*ld;
	int	rc;

	if ( argc != 4 ) {
		fprintf(stderr, "usage: %s dn type value\n", argv[0]);
		exit( 1 );
	}

	/* initialize the LDAP session */
	if ( (ld = ldap_init( "ggood", LDAP_PORT ))
	   == NULL) {
		perror( "ldap_init" );
		exit( 1 );
	}

	/* authenticate to the LDAP server */
	if ( ldap_simple_bind_s( ld, NULL, NULL ) != LDAP_SUCCESS ) {
		ldap_perror( ld, "ldap_simple_bind_s" );
		exit( 1 );
	}

	/* do the compare */
	rc = ldap_compare_s( ld, argv[1], argv[2], argv[3] );

	/* clean up */
	ldap_unbind( ld );

	if ( rc == LDAP_COMPARE_TRUE ) {
		printf( "TRUE\n" );
		return( 0 );
	} else {
		printf( "FALSE\n" );
		return( 1 );
	}
}
