#include <stdio.h>
#include <ldap.h>

#define ENTRYDN	"cn=Barbara Jensen, o=Ace Industry, c=US"
#define ENTRYPW	"hifalutin"

main( int argc, char **argv )
{
	LDAP	*ld;
	char	*mailvals[2];
	LDAPMod	mod;
	LDAPMod	*mods[2];

	/* initialize the LDAP session */
	if ( (ld = ldap_init( "ggood", LDAP_PORT ))
	   == NULL) {
		perror( "ldap_init" );
		exit( 1 );
	}

	/* authenticate to the LDAP server */
	if ( ldap_simple_bind_s( ld, ENTRYDN, ENTRYPW )
	    != LDAP_SUCCESS ) {
		ldap_perror( ld, "ldap_simple_bind_s" );
		exit( 1 );
	}

	/* construct the modification to make */
	mailvals[0] = "babs@ace.com";
	mailvals[1] = NULL;
	mod.mod_op = LDAP_MOD_REPLACE;
	mod.mod_type = "mail";
	mod.mod_values = mailvals;
	mods[0] = &mod;
	mods[1] = NULL;

	/* make the modification */
	if ( ldap_modify_s( ld, ENTRYDN, mods ) != LDAP_SUCCESS ) {
		ldap_perror( ld, "ldap_modify_s" );
		exit( 1 );
	}

	/* clean up */
	ldap_unbind( ld );
	return( 0 );
}
